﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace memcached.Tx
{
    internal class DecrementOp : KeyedOp
    {
        [System.Diagnostics.DebuggerHidden]
        public DecrementOp(ICacheAdvanced real, ICacheAdvanced temp, string key)
            : base(real, temp, key)
        {
        }

        private long? Original;
        private bool Done;

        public override string Name
        {
            [System.Diagnostics.DebuggerHidden]
            get { return "Dectement:" + Key; }
        }

        public override object Execute()
        {
            return ((ICacheAdvanced)Temp).Decrement(Key);
        }

        public override bool Persist()
        {
            bool res;
            object org = Store.Get(Key, out res);
            if (res)
            {
                if (org is long)
                    Original = (long)org;
                else
                    if (org is string)
                        Original = Convert.ToInt64((string)org);
                long newVal = ((ICacheAdvanced)Store).Decrement(Key);
                if (Original.HasValue)
                    res = newVal < Original.Value;
                else
                    res = newVal == 0;
            }
            Done = res;
            return Done;
        }

        public override bool Rollback()
        {
            if (Done)
                if (Original.HasValue)
                    return Store.Set(Key, Original.Value.ToString());// reset to original
                else
                    // the Key was not present before Decrement
                    return Store.Remove(Key);
            return true;// if it was not set, that nothing to reset
        }
    }
}